#!/bin/bash
# DO NOT EDIT THIS FILE

ocamlbuild warmup.byte
if [[ $? -ne 0 ]]; then
  cat <<EOF
===========================================================
WARNING

Your code currently does not compile.  You will receive
little to no credit for submitting this code. Check the
error messages above carefully to determine what is wrong.
See a consultant for help if you cannot determine what is
wrong.
===========================================================
EOF
  exit 1
fi

cat >checktypes.ml <<EOF
(* DO NOT EDIT THIS FILE *)
let check_valid_date : int -> string -> int -> bool = Warmup.valid_date
let check_syr : int -> int = Warmup.syr
let check_nacci : int -> int -> int list = Warmup.nacci
EOF

if ocamlbuild checktypes.byte ; then
  cat <<EOF
===========================================================
Your function names and types look good to me.
Congratulations!
===========================================================
EOF
else
  cat <<EOF
===========================================================
WARNING

Your function names and types look broken to me.  The code
that you submit might not compile on the grader's machine,
leading to heavy penalties.  Please fix your names and
types.  Check the error messages above carefully to
determine what is wrong.  See a consultant for help if you
cannot determine what is wrong.
===========================================================
EOF
fi
